﻿var
  next, prev: array[1..1000000] of int64;
  n, i, a, b: integer;
  f_in, f_out: text;

begin
  // Ввод данных и заполнение массивов чисел,
  // которые предшествуют данному (prev[i] предшествует i)
  // и следуют за данными (next[i] следует за i
  assign(f_in, 'input.txt'); reset(f_in);
  readln(f_in, n);
  for i := 1 to 1000000 do
  begin
    prev[i] := -1;
    next[i] := -1;
  end;
  for i := 1 to n - 1 do
  begin
    readln(f_in, a, b);
    prev[b] := a;
    next[a] := b;
  end;
  close(f_in);
  // Поиск числа, у которого нет предшественника
  i := 1;
  while not ((prev[i] = -1) and (next[i] <> -1)) do
    i := i + 1;
  // Получение ответа по массиву next и его запись
  assign(f_out, 'output.txt'); rewrite(f_out);
  a := i;
  for i := 1 to n - 1 do
  begin
    write(f_out, ' ', a);
    a := next[a];
  end;
  write(f_out, ' ', a);
  close(f_out);
end.